/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package cz.muni.fi.request.services;

import cz.muni.fi.request.beans.RequestLocal;
import cz.muni.fi.request.entities.Request;
import cz.muni.fi.request.entities.RequestState;
import java.util.List;
import javax.ejb.EJB;
import javax.jws.Oneway;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.ejb.Stateless;

/**
 *
 * @author Petr
 */
@WebService()
@Stateless()
public class RequestWS {
    @EJB
    private RequestLocal ejbRef;
    // Add business logic below. (Right-click in editor and choose
    // "Web Service > Add Operation"

    @WebMethod(operationName = "createRequest")
    public Long createRequest(@WebParam(name = "name") String name) throws Exception {
        return ejbRef.createRequest(name);
    }

    @WebMethod(operationName = "changeRequestState")
    @Oneway
    public void changeRequestState(@WebParam(name = "id") Long id, @WebParam(name = "state") RequestState state) {
        ejbRef.changeRequestState(id, state);
    }

    @WebMethod(operationName = "changeName")
    @Oneway
    public void changeName(@WebParam(name = "id") Long id, @WebParam(name = "name") String name) {
        ejbRef.changeName(id, name);
    }
    
    @WebMethod(operationName = "getAllRequests")
    public List<Request> getAllRequests() {
        return ejbRef.getAllRequests();
    }

    @WebMethod(operationName = "getRequestById")
    public Request getRequestById(@WebParam(name = "id") Long id) {
        return ejbRef.getRequestById(id);
    }

}
